float CalculateInterval(float flow_rate, float syringe_diam, int num_of_steps) {
  Serial.println("Calculating Interval");
  float step_dist = 50;

  float syringe_x_section = PI * (syringe_diam * syringe_diam) / 4; // Calculates Cross-Sectional Area of Syringe

  float delay_time = (step_dist * syringe_x_section * 10) / flow_rate; // Calculates Delay Time Required for Specified Flow Rate
  delay_time = round(delay_time);

  float half_delay_time;
  half_delay_time = delay_time / 2;
  float interval = round(half_delay_time);

  Serial.println("Interval (microseconds) =");
  Serial.println(interval);

  if (delay_time > delayLimit) {
    Serial.println("The delay time for the flow rate that you have specified is unsuitable with the syringe you have chosen.");
    Serial.println("Please use a syringe with a SMALLER inner lumen diameter.");
    delay(100000000);
  }

  return interval;
}

int CalculateNumSteps(float syringe_len) {
  Serial.println("Calculating Variables");
  Serial.println(" ");
  float step_dist = 25;
  step_dist = step_dist * 2;
  float num_of_steps = round(syringe_len * 100000 / (step_dist)); // Calculates the Final Steps required for the Total Distance specified
  Serial.println("Final Step no =");
  Serial.println(num_of_steps);

  return num_of_steps;
}

//------------------------------------------------------------------------

boolean CheckInterval(float interval) {
  unsigned long currentMicros = micros();
  if (currentMicros - previousMicros >= interval) {
    previousMicros = currentMicros;
    return true;
  } else {
    return false;
  }
}

//------------------------------------------------------------------------

void Forward_8th_Step_Mode(int pump) {
  if (pump == 0) {
    digitalWrite(stp_0, LOW);
    digitalWrite(dir_0, LOW);
    digitalWrite(MS1_0, HIGH);
    digitalWrite(MS2_0, HIGH);
    digitalWrite(EN_0, HIGH);
    Serial.println("Pump 0 mode: Forward 8th Step");

  } else if (pump == 1) {
    digitalWrite(stp_1, LOW);
    digitalWrite(dir_1, LOW);
    digitalWrite(MS1_1, HIGH);
    digitalWrite(MS2_1, HIGH);
    digitalWrite(EN_1, HIGH);
    Serial.println("Pump 1 mode: Forward 8th Step");

  } else if (pump == 2) {
    digitalWrite(stp_2, LOW);
    digitalWrite(dir_2, LOW);
    digitalWrite(MS1_2, HIGH);
    digitalWrite(MS2_2, HIGH);
    digitalWrite(EN_2, HIGH);
    Serial.println("Pump 2 mode: Forward 8th Step");
  }
}

void Reverse_Step_Mode(int pump) {
  if (pump == 0) {
    digitalWrite(stp_0, LOW);
    digitalWrite(dir_0, HIGH);
    digitalWrite(MS1_0, LOW);
    digitalWrite(MS2_0, LOW);
    digitalWrite(EN_0, HIGH);
    Serial.println("Pump 0 mode: Reverse Full Step");

  } else if (pump == 1) {
    digitalWrite(stp_1, LOW);
    digitalWrite(dir_1, HIGH);
    digitalWrite(MS1_1, LOW);
    digitalWrite(MS2_1, LOW);
    digitalWrite(EN_1, HIGH);
    Serial.println("Pump 1 mode: Reverse Full Step");

  } else if (pump == 2) {
    digitalWrite(stp_2, LOW);
    digitalWrite(dir_2, HIGH);
    digitalWrite(MS1_2, LOW);
    digitalWrite(MS2_2, LOW);
    digitalWrite(EN_2, HIGH);
    Serial.println("Pump 2 mode: Reverse Full Step");
  }
}

